import { PostfachMailListItemE2EComponent } from '../../components/postfach/postfach-mail.e2e.component';
import { PostfachNachrichtMessageCodeMessagesE2E } from '../../model/vorgang-attached-item';
import { PostfachMailPage } from '../../page-objects/postfach-mail.component.po';
import { contains, exist } from '../../support/cypress.util';

export class E2EPostfachNachrichtVerifier {
  private readonly postfachNachrichtPage: PostfachMailPage = new PostfachMailPage();

  public verifyFailedItemInList(subject: string): void {
    const item: PostfachMailListItemE2EComponent = this.getListItem(subject);
    this.verifyItemInList(subject);
    contains(item.getSendErrorText(), PostfachNachrichtMessageCodeMessagesE2E.PROCESSING_FAILED);
    exist(item.getSendErrorIcon());
    exist(item.getResendButton());
  }

  public verifyItemInList(subject: string): void {
    const item: PostfachMailListItemE2EComponent = this.getListItem(subject);
    contains(item.getSubject(), subject);
    exist(item.getUserProfile().getRoot());
    exist(item.getSentAt());
  }

  private getListItem(subject: string): PostfachMailListItemE2EComponent {
    return this.postfachNachrichtPage.getListItem(subject);
  }
}
