import { VorgangListE2EComponent } from '../../components/vorgang/vorgang-list.e2e.component';
import { waitForSpinnerToDisappear } from '../../page-objects/main.po';
import { exist } from '../../support/cypress.util';
import { E2EAppHelper } from '../app.helper';
import { E2EVorgangVerifier } from './vorgang.verifier';

export class E2EVorgangNavigator {
  private readonly appHelper: E2EAppHelper = new E2EAppHelper();

  private readonly verifier: E2EVorgangVerifier = new E2EVorgangVerifier();

  private readonly vorgangListPage = new VorgangListE2EComponent();

  public openVorgang(vorgangName: string): void {
    this.appHelper.navigateToDomain();
    waitForSpinnerToDisappear();
    exist(this.vorgangListPage.getRoot());

    this.vorgangListPage.getListItem(vorgangName).getRoot().click();
    this.verifier.verifyVorgangDetailOpen(vorgangName);
  }
}
