/*
 * Copyright (C) 2023 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { CommandResource } from '@alfa-client/command-shared';
import { PostfachMailLinkRel, PostfachMailResource, PostfachService } from '@alfa-client/postfach-shared';
import { StateResource } from '@alfa-client/tech-shared';
import { Component, inject, Input, OnInit } from '@angular/core';
import { Observable } from 'rxjs';

@Component({
  selector: 'alfa-outgoing-mail-error-container',
  templateUrl: './outgoing-mail-error-container.component.html',
  styleUrls: ['./outgoing-mail-error-container.component.scss'],
})
export class OutgoingMailErrorContainerComponent implements OnInit {
  @Input() postfachMailResource: PostfachMailResource;

  private readonly postfachService: PostfachService = inject(PostfachService);

  public resendPostfachMailStateResource$: Observable<StateResource<CommandResource>>;

  public readonly PostfachMailLinkRel = PostfachMailLinkRel;

  ngOnInit() {
    this.resendPostfachMailStateResource$ = this.postfachService.getPendingSendPostfachMailCommand();
  }

  public resendMail(): void {
    this.resendPostfachMailStateResource$ = this.postfachService.resendMail(this.postfachMailResource);
  }
}
